#line 1 "J:/I2C_test/I2C.c"

unsigned char const chip[]={" SCX-4200  SCX-4520  SCX-4720  SCX-5330  SCX-6320  ML-2150   ML-2250   ML-2550   ML-2850   ML-3470   ML-3560   PE-120    PE-220    WC-3119   WC-4118   Pha-3150  Pha-3420  Pha-3450  Pha-3500  M-20i    "};

char uart_rd;
char txt[16];
volatile unsigned short ByteRS, BUF;
volatile unsigned short N=1;



 sbit LCD_RS at RB2_bit;
 sbit LCD_EN at RB3_bit;
 sbit LCD_D4 at RB4_bit;
 sbit LCD_D5 at RB5_bit;
 sbit LCD_D6 at RB6_bit;
 sbit LCD_D7 at RB7_bit;

 sbit LCD_RS_Direction at TRISB2_bit;
 sbit LCD_EN_Direction at TRISB3_bit;
 sbit LCD_D4_Direction at TRISB4_bit;
 sbit LCD_D5_Direction at TRISB5_bit;
 sbit LCD_D6_Direction at TRISB6_bit;
 sbit LCD_D7_Direction at TRISB7_bit;




 void ReadEEPROM_24C256(char adr_h, char adr_l)

{
 I2C1_Start();
 if (I2C1_Wr(0xA2)) UART1_Write_Text("ERROR");
 I2C1_Wr(adr_h);
 I2C1_Wr(adr_l);
 I2C1_Repeated_Start();
 I2C1_Wr(0xA3);
 BUF = I2C1_Rd(0u);
 while (!I2C1_Is_Idle())
 asm nop;


 I2C1_Stop();
 Delay_ms(1);
 ByteRS=0;
}

 void ReadEEPROM_FULL_24C02(void)
{
 unsigned int i;
 for (i = 0; i<=255; i++)
 {
 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(i);
 I2C1_Repeated_Start();
 I2C1_Wr(0xA1);
 BUF = I2C1_Rd(1);
 while (!I2C1_Is_Idle())
 asm nop;
 I2C1_Stop();
 Delay_ms(1);
 UART1_Write(BUF);
 }
 ByteRS=0;
}

 void WriteEEPROM_0_bank(char adr)
 {

 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(adr);
 I2C1_Wr(BUF);
 I2C1_Stop();
 Delay_ms(5);
 ByteRS=0;
 }
#line 90 "J:/I2C_test/I2C.c"
 void CopyEEPROM(char adr_h, char adr_l, unsigned short N)
 {
 unsigned int i, q, y = 0;
 unsigned short BUF_1;
 char out[8];
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(2,2,"WRITING START");
 Delay_ms(50);
 for (i = 0; i<=255; i++)
 {
 ReadEEPROM_24C256(adr_h, i);
 WriteEEPROM_0_bank(i);
 if (!(i%32)) Lcd_Chr(1,y++,'-');
 }
 ByteRS=0;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 for (q=0; q<=9; q++)
 out[q] = chip[N*10 + q];
 for (q=0; q<=9; q++)
 UART1_Write(out[q]);
 Lcd_Out(1,3,out);
 Lcd_Out(1,11,"      ");
 Lcd_Out(2,2,"WRATING OK");
 Delay_ms(1);
 }

 void FormatEEPROM(void)
 {
 unsigned int i, y = 0;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(2,3,"FORMAT START");
 for (i = 0; i<=255; i++)
 {
 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(i);
 I2C1_Wr(0xFF);
 I2C1_Stop();
 if (!(i%32)) Lcd_Chr(1,y++,'-');
 Delay_ms(5);
 }
 ByteRS=0;
 UART1_Write_Text("FORMAT END");
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(2,2,"FORMAT END");
 Delay_ms(1);
 }



void interrupt() {

 if (PIR1.F5) {
 ByteRS=RCREG;
 PIR1.F5 = 0;
 }
}


void main()
{
 bit oldstate, oldstate0, oldstate1, oldstate2, oldstate3, oldstate4, oldstate5;
 unsigned short k;
 unsigned char out[10];
 TRISB=0b00000011;
 OPTION_REG.F7 = 0;
 TRISC=0b11111111;
 TRISA=0b11111111;
 PORTA=0b00111111;
 ADCON1 = 0x06;
 INTCON.F6 = 1;
 OPTION_REG.F6 = 1;
 INTCON.F4 = 0;
 PIE1.F5 = 1;
 INTCON.F7 = 1;
 UART1_Init(9600);
 Delay_ms(100);


 UART1_Write_Text("Start\n");
 ADCON1 = 0x06;
 I2C1_Init(100000);
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,"RUSSO_TURISTO");
 Lcd_Out(2,4,"COPY EEPROM");
 Delay_ms(1000);

 oldstate0 = oldstate1 = oldstate2 = oldstate3 = 0;

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 for (k=0; k<=9; k++)
 {
 out[k]=chip[N*10+k];
 }
 Lcd_Chr(1,8,N/10+0x30);
 Lcd_Chr(1,9,N%10+0x30);
 Lcd_Out(2,4,out);
 Lcd_Out(2,13,"   ");

 while (1) {
 if (Button(&PORTA, 0, 10, 0)) oldstate0 = 1;
 if (oldstate0 && Button(&PORTA, 0, 10, 1))
 {
 N=N+1;
 if (N>19) N=1;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 for (k=0; k<=9; k++)
 {
 out[k]=chip[N*10+k];
 }
 Lcd_Chr(1,8,N/10+0x30);
 Lcd_Chr(1,9,N%10+0x30);
 Lcd_Out(2,4,out);
 Lcd_Out(2,13,"    ");
 oldstate0 = 0;
 }

 if (Button(&PORTA, 1, 10, 0)) oldstate1 = 1;
 if (oldstate1 && Button(&PORTA, 1, 10, 1))
 {
 N=N-1;
 if (N<1) N=19;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 for (k=0; k<=9; k++)
 {
 out[k]=chip[N*10+k];
 }
 Lcd_Chr(1,8,N/10+0x30);
 Lcd_Chr(1,9,N%10+0x30);
 Lcd_Out(2,4,out);
 Lcd_Out(2,13,"    ");
 oldstate1 = 0;
 }

 if (Button(&PORTA, 2, 10, 0)) oldstate2 = 1;
 if (oldstate2 && Button(&PORTA, 2, 10, 1))
 {
 CopyEEPROM(2*(N-1), 0x00, N);

 oldstate2 = 0;
 }

 if (Button(&PORTA, 3, 10, 0)) oldstate3 = 1;
 if (oldstate3 && Button(&PORTA, 3, 10, 1))
 {
 FormatEEPROM();

 oldstate3 = 0;
 }
#line 269 "J:/I2C_test/I2C.c"
 }
 }
